﻿using System;

using Buddy.Wildstar.Engine;
using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

using log4net;


namespace Buddy.Wildstar.Plugins.MountShit
{
    class MountShit : IPlugin, IUIButtonProvider
    {
        private ILog Log = LogManager.GetLogger("MountShit");

        private static Player Me { get { return GameManager.LocalPlayer; } }
        public string Author { get { return "Illindar"; } }
        public string Name { get { return "MountShit"; } }
        public string Version { get { return "1.4"; } }
        public string Description { get { return "A very simple plugin, with a single focus, designed to extend rather than replace abilities of the Profile Bot. Cobbled together (or at least inspired by) from work by others on the WildBuddy forum. Particular thanks to Apoc, Deathdisguise, Paulmuadip, and Twist."; } }
        private float MountShitThrottleDelay = (RandNumber(100, 250))/100; // Set below as well. The time (in seconds) to suspend actions during Pulse() randomized a bit to make the bot to appear less 'botlke' 

        #region IPlugin Implementation

        private bool isEnabled;
        public bool Enabled
        {
            get { return isEnabled; }
            set { isEnabled = value; }
        }

        public void Initialize()
        {
            GameEngine.BotPulsator.RegisterForPulse(this);
        }

        public void Uninitialize()
        {
            GameEngine.BotPulsator.UnregisterForPulse(this);
        }

        private bool isPulsable = true;
        public bool CanBePulsed
        {
            get { return isPulsable; }
        }

        public void OnRegistered()
        {
        }

        public void OnUnregistered()
        {
        }

        private DateTime MountShitThrottleTimer = DateTime.Now;

        public void Pulse() {

            // Only evaluate actions every 'throttleDelay' seconds.  Throttle activities.
            if ((DateTime.Now - this.MountShitThrottleTimer).TotalSeconds < this.MountShitThrottleDelay) return;
            this.MountShitThrottleTimer = DateTime.Now;
            this.MountShitThrottleDelay = (RandNumber(100, 250)) / 100; // Setting again to force a change every tick
            
            DoWork();
                       
        }

        #endregion

        #region IUIButtonProvider

        public string ButtonText
        {
            get { return "Settings"; }
        }

        public void OnButtonClicked(object sender)
        {
        }

        #endregion

        public static int RandNumber(int Low, int High)
        {
                Random rndNum = new Random(int.Parse(Guid.NewGuid().ToString().Substring(0, 8), System.Globalization.NumberStyles.HexNumber));
                int rnd = rndNum.Next(Low, High);
                return rnd;
        }

        private async void DoWork()
        {
            // Loading screen, do nothing.
            if (GameManager.WorldLoadState != WorldLoadState.InWorld)
                return;

           // Sanity checks.
            if (Me == null || !Me.IsValid || Me.IsDead || !Me.IsAlive )
                return;

           // If in combat, casting or occupied. do nothing.
            if (Me.IsInCombat || Me.IsCasting || Me.IsBusy)
                return;
            
            // Don't do anything if a window is open.
 //           if ((int)GameManager.CurrentOpenWindowType != 99)
 //               return;

            // Not taking a field trip someplace (moving may be overkill, will need to test)
             if (Me.IsOnTaxi || Me.IsMounted || Me.IsMoving || Me.IsOnVehicle) 
                return;

            if (GameManager.IsCinematicPlaying)
            return;

            //            if (GameManager.CanVacuum && GameManager.Inventory.Bags.FreeSlots + 1 > 0)

            //                <!-- <InputAction Action="Mount" /> --> 


            if (!Me.IsMounted && !Me.HasBuff("Stealth"))
            {
                //Log.Info("Mountitg shit ");
                //Log.Info(GameManager.LocalPlayer.VehicleGuid);
                var MountSlot = SpellManager.GetMiscSpell(MiscSpellType.Mount);
                if (MountSlot != null)
                {
                    if (MountSlot.CanCast)
                    {
                        //Log.Warn(SpellManager.GetMiscSpell(MiscSpellType.Mount).CooldownFlags);
                        GameManager.InputManager.KeyPress(InputAction.Mount);
                    }
                }          
                    
                    
//                GameManager.InputManager.KeyPress(InputAction.Mount);
            }
            return;

        }

    }
}
